---
title: CONNECT
slug: Web/HTTP/Methods/CONNECT
tags:
  - HTTP
  - Reference
  - Request method
---
<div>{{HTTPSidebar}}</div>

<p>The <strong>HTTP <code>CONNECT</code> method</strong> starts two-way communications with the requested resource. It can be used to open a tunnel.</p>

<p>For example, the <code>CONNECT</code> method can be used to access websites that use {{Glossary("SSL")}} ({{Glossary("HTTPS")}}). The client asks an HTTP {{Glossary("Proxy server")}} to tunnel the <a href="/en-US/docs/Glossary/Transmission_Control_Protocol_(TCP)">TCP</a> connection to the desired destination. The server then proceeds to make the connection on behalf of the client. Once the connection has been established by the server, the {{Glossary("Proxy server")}} continues to proxy the <a href="/en-US/docs/Glossary/Transmission_Control_Protocol_(TCP)">TCP</a> stream to and from the client.</p>

<p><code>CONNECT</code> is a hop-by-hop method.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Request has body</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Successful response has body</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Safe")}}</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Idempotent")}}</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Cacheable")}}</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Allowed in <a href="/en-US/docs/Web/Guide/HTML/Forms">HTML forms</a></th>
   <td>No</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">CONNECT www.example.com:443 HTTP/1.1
</pre>

<h2 id="Example">Example</h2>

<p>Some proxy servers might need authority to create a tunnel. See also the {{HTTPHeader("Proxy-Authorization")}} header.</p>

<pre class="line-numbers  language-html">CONNECT server.example.com:80 HTTP/1.1
Host: server.example.com:80
Proxy-Authorization: basic aGVsbG86d29ybGQ=</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7231", "CONNECT", "4.3.6")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.methods.CONNECT")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{Glossary("Proxy server")}}</li>
 <li>{{HTTPHeader("Proxy-Authorization")}}</li>
</ul>
